import { getState, updateState } from '../state';
import { initCache } from './initialValues';
export var shouldRecover = function (error) {
    var _a = getState(), options = _a.options, token = _a.cache.token, recoveryTries = _a.recoveryTries;
    var response = error.response;
    if (!response) {
        return false;
    }
    var status = response.status;
    var refreshOnStatus = options.refreshOnStatus, maxRecoveryTries = options.maxRecoveryTries, onAuthFail = options.onAuthFail, onRecoveryAbort = options.onRecoveryAbort, addTokenToLogs = options.addTokenToLogs;
    var authFailed = refreshOnStatus.includes(status);
    if (authFailed) {
        var access_token = token.access_token;
        var message = addTokenToLogs ? "Used token: ".concat(access_token) : '';
        onAuthFail(message);
        if (recoveryTries < maxRecoveryTries) {
            updateState({
                inRecovery: true,
                recoveryTries: recoveryTries + 1,
                cache: initCache
            });
            return true;
        }
        else {
            updateState({
                inRecovery: false,
                recoveryTries: 0,
                cache: initCache
            });
            onRecoveryAbort();
        }
    }
    return false;
};
